/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.AgreementSection;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class AgreementSection : ObjectG
{
	/** the main Gtk struct */
	protected AsAgreementSection* asAgreementSection;

	/** Get the main Gtk struct */
	public AsAgreementSection* getAgreementSectionStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asAgreementSection;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asAgreementSection;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsAgreementSection* asAgreementSection, bool ownedRef = false)
	{
		this.asAgreementSection = asAgreementSection;
		super(cast(GObject*)asAgreementSection, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_agreement_section_get_type();
	}

	/**
	 * Creates a new #AsAgreementSection.
	 *
	 * Returns: a #AsAgreementSection
	 *
	 * Since: 0.12.1
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_agreement_section_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsAgreementSection*) __p, true);
	}

	/**
	 * Get the current active locale, which
	 * is used to get localized messages.
	 */
	public string getActiveLocale()
	{
		return Str.toString(as_agreement_section_get_active_locale(asAgreementSection));
	}

	/**
	 * Gets the agreement section desc.
	 *
	 * Returns: a string, e.g. "GDPR", or NULL
	 *
	 * Since: 0.12.1
	 */
	public string getDescription()
	{
		return Str.toString(as_agreement_section_get_description(asAgreementSection));
	}

	/**
	 * Gets the agreement section kind.
	 *
	 * Returns: a string, e.g. "GDPR", or NULL
	 *
	 * Since: 0.12.1
	 */
	public string getKind()
	{
		return Str.toString(as_agreement_section_get_kind(asAgreementSection));
	}

	/**
	 * Gets the agreement section name.
	 *
	 * Returns: a string, e.g. "GDPR", or NULL
	 *
	 * Since: 0.12.1
	 */
	public string getName()
	{
		return Str.toString(as_agreement_section_get_name(asAgreementSection));
	}

	/**
	 * Set the current active locale, which
	 * is used to get localized messages.
	 */
	public void setActiveLocale(string locale)
	{
		as_agreement_section_set_active_locale(asAgreementSection, Str.toStringz(locale));
	}

	/**
	 * Sets the agreement section desc.
	 *
	 * Params:
	 *     desc = the agreement description, e.g. "GDPR"
	 *     locale = the locale. e.g. "en_GB"
	 *
	 * Since: 0.12.1
	 */
	public void setDescription(string desc, string locale)
	{
		as_agreement_section_set_description(asAgreementSection, Str.toStringz(desc), Str.toStringz(locale));
	}

	/**
	 * Sets the agreement section kind.
	 *
	 * Params:
	 *     kind = the agreement kind, e.g. "GDPR"
	 *
	 * Since: 0.12.1
	 */
	public void setKind(string kind)
	{
		as_agreement_section_set_kind(asAgreementSection, Str.toStringz(kind));
	}

	/**
	 * Sets the agreement section name.
	 *
	 * Params:
	 *     name = the agreement name, e.g. "GDPR"
	 *     locale = the locale. e.g. "en_GB"
	 *
	 * Since: 0.12.1
	 */
	public void setName(string name, string locale)
	{
		as_agreement_section_set_name(asAgreementSection, Str.toStringz(name), Str.toStringz(locale));
	}
}
