/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Branding;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class Branding : ObjectG
{
	/** the main Gtk struct */
	protected AsBranding* asBranding;

	/** Get the main Gtk struct */
	public AsBranding* getBrandingStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asBranding;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asBranding;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsBranding* asBranding, bool ownedRef = false)
	{
		this.asBranding = asBranding;
		super(cast(GObject*)asBranding, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_branding_get_type();
	}

	/**
	 * Creates a new #AsBranding.
	 *
	 * Returns: a #AsBranding
	 *
	 * Since: 0.10
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_branding_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsBranding*) __p, true);
	}

	/**
	 * Retrieve a color of the given @kind that matches @scheme_kind.
	 * If a color has no scheme preference defined, it will be returned for either scheme type,
	 * unless a more suitable color was found.
	 *
	 * Params:
	 *     kind = the #AsColorKind, e.g. %AS_COLOR_KIND_PRIMARY.
	 *     schemeKind = Color scheme preference for the color, e.g. %AS_COLOR_SCHEME_KIND_LIGHT
	 *
	 * Returns: The HTML color code of the found color, or %NULL if no color was found.
	 *
	 * Since: 0.15.2
	 */
	public string getColor(AsColorKind kind, AsColorSchemeKind schemeKind)
	{
		return Str.toString(as_branding_get_color(asBranding, kind, schemeKind));
	}

	/**
	 * Deletes a color that matches the given type and scheme preference.
	 *
	 * Params:
	 *     kind = the #AsColorKind, e.g. %AS_COLOR_KIND_PRIMARY.
	 *     schemePreference = Type of color scheme preferred for this color, e.g. %AS_COLOR_SCHEME_KIND_LIGHT
	 *
	 * Since: 0.15.2
	 */
	public void removeColor(AsColorKind kind, AsColorSchemeKind schemePreference)
	{
		as_branding_remove_color(asBranding, kind, schemePreference);
	}

	/**
	 * Sets a new accent color. If a color of the given kind with the given scheme preference already exists,
	 * it will be overriden with the new color code.
	 *
	 * Params:
	 *     kind = the #AsColorKind, e.g. %AS_COLOR_KIND_PRIMARY.
	 *     schemePreference = Type of color scheme preferred for this color, e.g. %AS_COLOR_SCHEME_KIND_LIGHT
	 *     colorcode = a HTML color code.
	 *
	 * Since: 0.15.2
	 */
	public void setColor(AsColorKind kind, AsColorSchemeKind schemePreference, string colorcode)
	{
		as_branding_set_color(asBranding, kind, schemePreference, Str.toStringz(colorcode));
	}
}
