/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Video;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class Video : ObjectG
{
	/** the main Gtk struct */
	protected AsVideo* asVideo;

	/** Get the main Gtk struct */
	public AsVideo* getVideoStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asVideo;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asVideo;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsVideo* asVideo, bool ownedRef = false)
	{
		this.asVideo = asVideo;
		super(cast(GObject*)asVideo, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_video_get_type();
	}

	/**
	 * Creates a new #AsVideo.
	 *
	 * Returns: a #AsVideo
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_video_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsVideo*) __p, true);
	}

	/**
	 * Gets the video codec, if known.
	 *
	 * Returns: the #AsVideoCodecKind
	 */
	public AsVideoCodecKind getCodecKind()
	{
		return as_video_get_codec_kind(asVideo);
	}

	/**
	 * Gets the video container format, if known.
	 *
	 * Returns: the #AsVideoContainerKind
	 */
	public AsVideoContainerKind getContainerKind()
	{
		return as_video_get_container_kind(asVideo);
	}

	/**
	 * Gets the video height, if known.
	 *
	 * Returns: height in pixels or 0 if unknown
	 */
	public uint getHeight()
	{
		return as_video_get_height(asVideo);
	}

	/**
	 * Get locale for this video.
	 *
	 * Returns: Locale string
	 */
	public string getLocale()
	{
		return Str.toString(as_video_get_locale(asVideo));
	}

	/**
	 * Gets the full qualified URL for the video, usually pointing at a mirror or CDN server.
	 *
	 * Returns: a web URL
	 */
	public string getUrl()
	{
		return Str.toString(as_video_get_url(asVideo));
	}

	/**
	 * Gets the video width, if known.
	 *
	 * Returns: width in pixels or 0 if unknown
	 */
	public uint getWidth()
	{
		return as_video_get_width(asVideo);
	}

	/**
	 * Sets the video codec.
	 *
	 * Params:
	 *     kind = the #AsVideoCodecKind, e.g. %AS_VIDEO_CODEC_KIND_AV1.
	 */
	public void setCodecKind(AsVideoCodecKind kind)
	{
		as_video_set_codec_kind(asVideo, kind);
	}

	/**
	 * Sets the video container.
	 *
	 * Params:
	 *     kind = the #AsVideoContainerKind, e.g. %AS_VIDEO_CONTAINER_KIND_MKV.
	 */
	public void setContainerKind(AsVideoContainerKind kind)
	{
		as_video_set_container_kind(asVideo, kind);
	}

	/**
	 * Sets the video height.
	 *
	 * Params:
	 *     height = the height in pixels.
	 */
	public void setHeight(uint height)
	{
		as_video_set_height(asVideo, height);
	}

	/**
	 * Sets the locale for this video.
	 *
	 * Params:
	 *     locale = the locale string.
	 */
	public void setLocale(string locale)
	{
		as_video_set_locale(asVideo, Str.toStringz(locale));
	}

	/**
	 * Sets the fully-qualified URL to use for the video.
	 *
	 * Params:
	 *     url = the URL.
	 */
	public void setUrl(string url)
	{
		as_video_set_url(asVideo, Str.toStringz(url));
	}

	/**
	 * Sets the video width.
	 *
	 * Params:
	 *     width = the width in pixels.
	 */
	public void setWidth(uint width)
	{
		as_video_set_width(asVideo, width);
	}
}
