/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module ascompose.IconPolicy;

private import ascompose.c.functions;
public  import ascompose.c.types;
private import glib.ConstructionException;
private import gobject.ObjectG;


/** */
public class IconPolicy : ObjectG
{
	/** the main Gtk struct */
	protected AscIconPolicy* ascIconPolicy;

	/** Get the main Gtk struct */
	public AscIconPolicy* getIconPolicyStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return ascIconPolicy;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)ascIconPolicy;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AscIconPolicy* ascIconPolicy, bool ownedRef = false)
	{
		this.ascIconPolicy = ascIconPolicy;
		super(cast(GObject*)ascIconPolicy, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return asc_icon_policy_get_type();
	}

	/**
	 * Creates a new #AscIconPolicy.
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = asc_icon_policy_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AscIconPolicy*) __p, true);
	}

	/**
	 * Sets a designated state for an icon of the given size.
	 *
	 * Params:
	 *     iconSize = the size of the icon to set policy for (e.g. 64 for 64x64px icons)
	 *     iconScale = the icon scale factor, e.g. 1
	 *     state = the designated #AscIconState
	 */
	public void setPolicy(uint iconSize, uint iconScale, AscIconState state)
	{
		asc_icon_policy_set_policy(ascIconPolicy, iconSize, iconScale, state);
	}
}
